import { RequestHandler } from 'express';
import { ProductService } from '@/services/product.service';
import { plainToInstance } from 'class-transformer';
import { ProductDto } from '@/dto/ProductDto';

export class ProductController {
  private service: ProductService;

  constructor() {
    this.service = new ProductService();
  }

  getProducts: RequestHandler = (req, res): void => {
    const products = this.service.getProducts();
    res.send(products);
  };
  getProduct: RequestHandler = (req, res): void => {
    const product = this.service.getProduct(req.params.id);
    res.send(product);
  };
  createProduct: RequestHandler = (req, res): void => {
    const productDto = plainToInstance(ProductDto, req.body);
    const product = this.service.createProduct(productDto);
    res.send(product);
  };
}
